#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#define PI 3.14159265358979323

static int PN[1024];

void random_function();
void m_sequence();

int main(void)
{
	FILE* out_file;
	char fname[255];
	
	static double  gr[65536], gi[65536],power_sp[65536], average[1024];
	int i, j, t, n, m, flg, fft();
   	int sampling_frequency=64;
	int carrier_frequency=16;		// carrier frequency
	int chips=1024;
	double wc;
	int a=512;
	int b=128;

	sprintf( fname,"output434.csv");
	out_file = fopen( fname, "w");
	
	flg=1;
	
	wc=2*PI*carrier_frequency;
	
	random_function();
	//m_sequence();
		
	// input the value by sampling into real part
	for (i=0 ; i<chips ; i++ )  // 1024 chips
	{
		for ( j=0 ; j<sampling_frequency ; j++ ) // 64 sample
		{
			if ( PN[i]==1 )
				gr[i*sampling_frequency+j ]= 1.0*cos(wc*(double)j/(double)sampling_frequency);
			
			else if ( PN[i]==0 )
				gr[i*sampling_frequency+j ]= -1.0*cos(wc*(double)j/(double)sampling_frequency);
			
			gi[i*sampling_frequency+j ]= 0.0;		/* 0.0*/
		}
	}
	
   	fft( chips*sampling_frequency, gr, gi, flg );
   	
    for( i=0; i<chips*sampling_frequency; i++)
	{
		power_sp[i] = (gr[i]*gr[i]+gi[i]*gi[i]);
	}
   	
	for ( i=0 ; i<a ; i++ )
	{
	    for( j=0; j<b; j++)
		{
			if((i*b+j-b/2)<0)
			{
				average[i]+=power_sp[(i*b+j-b/2)+65536];
				//if(i==0){
				//	//printf("%d:%f\n",(i*b+j-b/2),power_sp[(i*b+j-b/2)+65536]);
				//}
			}else
			{
				average[i]+=power_sp[i*b+j-b/2];
				//if(i==0){
				//	//printf("%d:%f\n",(i*b+j-b/2),power_sp[i*b+j-b/2]);
				//}
			}
		}
		//if(i==0){
		//	//printf("avr=%f\n",average[i]/b);
		//}
	}
	
	for( i=a/2; i<a ; i++)
	{
		printf("%d,%f\n",i-a, average[i]/b);
		fprintf(out_file, "%d,%f\n",i-a, average[i]/b );
	}
	for( i=0; i<a/2 ; i++)
	{
		printf("%d,%f\n",i, average[i]/b);
		fprintf(out_file, "%d,%f\n",i, average[i]/b );
	}	
	
	//for( i=0; i<65536;i++)
	//{
	//	printf("%d,%f\n",i, power_sp[i]);
	//}
	
	fclose(out_file);
	return 0;
}

fft( n, gr, gi, flg )
int n, flg;
double gr[], gi[];
{
	int   i, j, step, l, nl, m, sp, spd2;
	unsigned long int   li, lc;
	double   temp, tempr, tempi, arg, d_arg, co, si;

   	/*   bit reversal   */
   	for( j=n,m=0; j>=2; j/=2 ) 
		m++;
	
	for( j=0; j<n; j++ )
    {
    	li = j;
	    for( lc = 0, l=0; l<m; l++)
    		 lc <<= 1,  lc += li & 1, li >>= 1;
	   	if( j > lc )
    	{
     		temp = gr[j]; gr[j] = gr[lc]; gr[lc] = temp;
		    temp = gi[j]; gi[j] = gi[lc]; gi[lc] = temp;
    	}
    }
	
	/*   fft main   */
	for( step=1; step<=m; step++ )
    {
		for( i=0,sp=1; i<step; i++ )  
			sp *= 2;
      	
		spd2 = sp / 2;
	 	
     	arg = -(double)flg * PI / (double)spd2;
     	
	  	for( j=0; j<spd2; j++ )
        {
			co = cos( arg * (double)j ), si = sin( arg * (double)j );
			
			for( l=j; l<n; l+=sp )
			{
				nl = l + spd2;
				tempr = gr[nl]*co - gi[nl]*si;  tempi = gr[nl]*si + gi[nl]*co;
				gr[nl] = gr[l] - tempr;         gi[nl] = gi[l] - tempi;
				gr[l] = gr[l] + tempr;          gi[l] = gi[l] + tempi;
            }
    	}
    }
	
	
	if( flg==1 )
	{
		for( i=0; i<n; i++ )
		{
			gr[i] /= (double)n;
			gi[i] /= (double)n;
		}
	}
	
	return ( 1 );
}

void random_function()
{
	double x;
	int i;
	
	for ( i=0 ; i<1024 ; i++ )
	{
		x=rand()/(double)RAND_MAX;
		//printf("%f\n",x);
		if ( x>0.5 )
			PN[i]=1;
		else 
			PN[i]=0;
	}
}


/*  10 bit shift register琶ꂽMn : 1023+1 chips */
void m_sequence()
{
	int shift_register = 0x03ff;
	int a,b,s;
	int i,n=1023;
	
	for ( i=0 ; i<n ; i++ )
	{
		a=shift_register>>2 &0x0001;
		b=shift_register>>9 &0x0001;
		
		s=a+b;
		PN[i]=s%2;
		
		if ( s%2 == 0)
		{
			shift_register = shift_register << 1 | 0x0000 ;
			shift_register = shift_register & 0x3fff ;
		}else if ( s%2 == 1 )
		{
			shift_register = shift_register << 1 | 0x0001 ;
			shift_register = shift_register & 0x3fff ;
			
		}
		s=0;
		
		//printf("%d\n",PN[i]);
	}
	
	PN[n]=0;
	
}



