#include"bitmap.h"
#include<stdlib.h>
#include<stdio.h>
#include<math.h>
#include<string.h>

#define W 256
#define H 256
#define FFT_MAX	256

void FFT2(int flag);									// 2FFT
void FFT( int n, double gr[], double gi[], int flg );	// 1FFT
void Filtering(int flag);								// LPF܂HPF
void Power_Spectrum();									// p[XyNg
void output(double Data[H][W]);							// t@C֏o

unsigned char grayimg[H][W];	// f̋PxlۊǗp
double  data[FFT_MAX][FFT_MAX];	// FFTReal Partp
double jdata[FFT_MAX][FFT_MAX];	// FFTImaginary Partp
double   PWR[FFT_MAX][FFT_MAX];	// p[XyNgp

double  tPWR[FFT_MAX][FFT_MAX];	// p[XyNg

int main()
{
	int i,j;
	double max=0;
	double rate;
	
	Image *colorimg;	// image\́@bitmap.hɒ`
	
	char input_fname[256] ="lena.bmp" ;			// ̓t@C
	char output_fname[256]="lena2.bmp";			// o̓t@C
	
	if((colorimg = Read_Bmp(input_fname)) == NULL){
		exit(1);
	}
	
	// Color摜Grayscale֕ϊ
	for ( i=0 ; i<H ; i++ )
	{
		for ( j=0 ; j<W ; j++ )
		{
			grayimg[i][j] = (unsigned char)(0.299*(unsigned char)colorimg->data[i*W+j].r 
						  				  + 0.587*(unsigned char)colorimg->data[i*W+j].g
										  + 0.114*(unsigned char)colorimg->data[i*W+j].b);
		}
	}
	
	// FFT͗pf[^
    for ( i=0 ; i<FFT_MAX ; i++ )
	{
        for ( j=0 ; j<FFT_MAX ; j++ )
		{
             data[i][j] = (unsigned char)grayimg[i][j];
            jdata[i][j] = 0.0;
        }
    }
	
	// 2FFT
	FFT2(1);	// 1:FFT, -1:IFFT	
	
	// tB^ςĂI
	Filtering(  1 );	// 1:LPF, 2:HPF
	
	///
	FFT2(-1);	// 1:FFT, -1:IFFT
	
	// tB^ʂ̌ʂo͂邽߂̏
	for ( i=0 ; i<H ; i++ )
	{
		for ( j=0 ; j<W ; j++ )
		{
			if ( 255<data[i][j] )
			{
				colorimg->data[i*W+j].r = (unsigned char) 255;
				colorimg->data[i*W+j].g = (unsigned char) 255;
				colorimg->data[i*W+j].b = (unsigned char) 255;
				
			}else
			{
				colorimg->data[i*W+j].r = (unsigned char) data[i][j];
				colorimg->data[i*W+j].g = (unsigned char) data[i][j];
				colorimg->data[i*W+j].b = (unsigned char) data[i][j];
			}
		}
	}
	
	// t@C̏o
	if(Write_Bmp(output_fname, colorimg))
	{
		exit(1);
	}

	Free_Image(colorimg);

	return 0;
}


// flagɂLPF,HPF
void Filtering(int flag)
{
	int i, j;
	int intv;	// Filteȓ傫
	
	if ( flag == 1 )
		intv = 24;	// 24*2
	else
		intv = 32;	// 32*2
	
	if ( flag == 1 )
	{
		for ( i=0 ; i<intv ; i++ )
		{
			for ( j=intv ; j<FFT_MAX-intv ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
			}
		}
	    for ( i=intv ; i<FFT_MAX-intv ; i++ )
		{
			for ( j=0 ; j<intv ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
				
			}
		}		
	    for ( i=intv ; i<FFT_MAX-intv ; i++ )
		{
			for ( j=FFT_MAX-intv ; j<FFT_MAX ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
				
			}
		}
		for ( i=FFT_MAX-intv ; i<FFT_MAX ; i++ )
		{
			for ( j=intv ; j<FFT_MAX-intv ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
			}
		}
		for ( i=intv ; i<FFT_MAX-intv ; i++ )
		{
			for ( j=intv ; j<FFT_MAX-intv ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
			}
		}
				
	} else if ( flag == 2 )
	{
	    for ( i=0 ; i<intv ; i++ )
		{
			for ( j=0 ; j<intv ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
				
			}
		}
	    for ( i=0 ; i<intv ; i++ )
		{
			for ( j=FFT_MAX-intv ; j<FFT_MAX ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
				
			}
		}
	    for ( i=FFT_MAX-intv ; i<FFT_MAX ; i++ )
		{
			for ( j=0 ; j<intv ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
				
			}
		}
	    for ( i=FFT_MAX-intv ; i<FFT_MAX ; i++ )
		{
			for ( j=FFT_MAX-intv ; j<FFT_MAX ; j++ )
			{
				 data[i][j]=0.0;
				jdata[i][j]=0.0;
				
			}
		}
		
	}
	
}

// f[^csvt@C֏o͂֐
void output(double Data[H][W])
{
	int x, y;

	FILE* out_file;
	char filename[255];

	sprintf(filename,"output.csv");

	out_file = fopen(filename,"w");

	for ( y=0 ; y<H ; y++ )
	{
		for ( x=0 ; x<W ; x++ )
		{
			if (x<W-1)
				fprintf(out_file,"%f,", Data[y][x] );
			else
				fprintf(out_file,"%f",  Data[y][x] );
		}
		fprintf(out_file,"\n");
	}

	fclose(out_file);
	
}

// 2FFTs֐
void FFT2(int flag)
{
	int i,j ;
	double gr[FFT_MAX], gi[FFT_MAX];

	// 
	for ( i=0 ; i<FFT_MAX ; i++ )
	{
		for ( j=0 ; j<FFT_MAX ; j++ )
		{
            gr[j] =  data[i][j];
            gi[j] = jdata[i][j];
		}
		
		FFT( FFT_MAX, gr, gi, flag );
		
		for ( j=0 ; j<FFT_MAX ; j++ )
		{
             data[i][j] = gr[j];
            jdata[i][j] = gi[j];
		}
	}

	// c
	for ( i=0 ; i<FFT_MAX ; i++ )
	{
		for ( j=0 ; j<FFT_MAX ; j++ )
		{
            gr[j] =  data[j][i];
            gi[j] = jdata[j][i];

		}
		
		FFT( FFT_MAX, gr, gi, flag );
		
		for ( j=0 ; j<FFT_MAX ; j++ )
		{
             data[j][i] = gr[j];
            jdata[j][i] = gi[j];
		}
	}
}

// 1FFTs֐
void FFT( int n, double gr[], double gi[], int flg )
{
	int   i, j, step, l, nl, m, sp, spd2;
	unsigned long int   li, lc;
	double   temp, tempr, tempi, arg, d_arg, co, si;

   	/*   bit reversal   */

   	for( j=n,m=0; j>=2; j/=2 ) 
		m++;

	for( j=0; j<n; j++ )
    {
    	li = j;
	    for( lc = 0, l=0; l<m; l++)
    		 lc <<= 1,  lc += li & 1, li >>= 1;
	
		if( j > lc )
   		{
   	 		temp = gr[j]; gr[j] = gr[lc]; gr[lc] = temp;
			temp = gi[j]; gi[j] = gi[lc]; gi[lc] = temp;
       	}
    }

	/*   fft main   */	
	for( step=1; step<=m; step++ )
    {
		for( i=0,sp=1; i<step; i++ )  
			sp *= 2;
      	
		spd2 = sp / 2;
	  
      	arg = -(double)flg * M_PI / (double)spd2;
      
	  	for( j=0; j<spd2; j++ )
        {
      	   	co = cos( arg * (double)j ), si = sin( arg * (double)j );
        
			for( l=j; l<n; l+=sp )
            {
            	nl = l + spd2;
            	tempr = gr[nl]*co - gi[nl]*si;  tempi = gr[nl]*si + gi[nl]*co;
            	gr[nl] = gr[l] - tempr;         gi[nl] = gi[l] - tempi;
            	gr[l] = gr[l] + tempr;          gi[l] = gi[l] + tempi;
            }
        }
	}

	if( flg==1 ) 
   		for( i=0; i<n; i++ ) gr[i] /= (double)n, gi[i] /= (double)n;
  
}



//filenameBitmapt@Cǂݍ݁AƕARGBimg\̂ɓ
Image *Read_Bmp(char *filename)
{
	int i, j;
	int real_width;					//f[^1s̃oCg
	unsigned int width, height;			//摜̉Əc̃sNZ
	unsigned int color;			//bitBitmapt@Cł邩
	FILE *fp;
	unsigned char header_buf[HEADERSIZE];	//wb_荞
	unsigned char *bmp_line_data;  //摜f[^1s
	Image *img;

	if((fp = fopen(filename, "rb")) == NULL)
	{
		fprintf(stderr, "Error: %s could not read.", filename);
		return NULL;
	}

	fread(header_buf, sizeof(unsigned char), HEADERSIZE, fp); //wb_SĂ荞

	//ŏ2oCgBM(Bitmapt@C̈)ł邩
	if(strncmp(header_buf, "BM", 2))
	{
		fprintf(stderr, "Error: %s is not Bitmap file.", filename);
		return NULL;
	}

	memcpy(&width, header_buf + 18, sizeof(width)); //摜̌ڏ̕擾
	memcpy(&height, header_buf + 22, sizeof(height)); //摜̍擾
	memcpy(&color, header_buf + 28, sizeof(unsigned int)); //bitBitmapł邩擾

	//24bitŖΏI
	if(color != 24){
		fprintf(stderr, "Error: %s is not 24bit color image", filename);
		return NULL;
	}

	//RGB͉摜1s4byte̔{Ŗ΂ȂȂ߂ɍ킹Ă
	real_width = width*3 + width%4;

	//摜1sRGBĂ邽߂̃obt@𓮓IɎ擾
	if((bmp_line_data = (unsigned char *)malloc(sizeof(unsigned char)*real_width)) == NULL){
		fprintf(stderr, "Error: Allocation error.\n");
		return NULL;
	}

	//RGB荞ނ߂̃obt@𓮓IɎ擾
	if((img = Create_Image(width, height)) == NULL){
		free(bmp_line_data);
		fclose(fp);
		return NULL;
	}

	//Bitmapt@CRGB͍EցAɕł
	for(i=0; i<height; i++)
	{
		fread(bmp_line_data, 1, real_width, fp);
		for(j=0; j<width; j++)
		{
			img->data[(height-i-1)*width + j].b = bmp_line_data[j*3];
			img->data[(height-i-1)*width + j].g = bmp_line_data[j*3 + 1];
			img->data[(height-i-1)*width + j].r = bmp_line_data[j*3 + 2];
		}
	}

	free(bmp_line_data);

	fclose(fp);

	return img;
}

int Write_Bmp(char *filename, Image *img)
{
	int i, j;
	FILE *fp;
	int real_width;
	unsigned char *bmp_line_data; //摜1sRGBi[
	unsigned char header_buf[HEADERSIZE]; //wb_i[
	unsigned int file_size;
	unsigned int offset_to_data;
	unsigned long info_header_size;
	unsigned int planes;
	unsigned int color;
	unsigned long compress;
	unsigned long data_size;
	long xppm;
	long yppm;

	if((fp = fopen(filename, "wb")) == NULL){
		fprintf(stderr, "Error: %s could not open.", filename);
		return 1;
	}

	real_width = img->width*3 + img->width%4;

	//wb_쐬
	file_size = img->height * real_width + HEADERSIZE;
	offset_to_data = HEADERSIZE;
	info_header_size = INFOHEADERSIZE;
	planes = 1;
	color = 24;
	compress = 0;
	data_size = img->height * real_width;
	xppm = 1;
	yppm = 1;
	
	header_buf[0] = 'B';
	header_buf[1] = 'M';
	memcpy(header_buf + 2, &file_size, sizeof(file_size));
	header_buf[6] = 0;
	header_buf[7] = 0;
	header_buf[8] = 0;
	header_buf[9] = 0;
	memcpy(header_buf + 10, &offset_to_data, sizeof(file_size));
	header_buf[11] = 0;
	header_buf[12] = 0;
	header_buf[13] = 0;

	memcpy(header_buf + 14, &info_header_size, sizeof(info_header_size));
	header_buf[15] = 0;
	header_buf[16] = 0;
	header_buf[17] = 0;
	memcpy(header_buf + 18, &img->width, sizeof(img->width));
	memcpy(header_buf + 22, &img->height, sizeof(img->height));
	memcpy(header_buf + 26, &planes, sizeof(planes));
	memcpy(header_buf + 28, &color, sizeof(color));
	memcpy(header_buf + 30, &compress, sizeof(compress));
	memcpy(header_buf + 34, &data_size, sizeof(data_size));
	memcpy(header_buf + 38, &xppm, sizeof(xppm));
	memcpy(header_buf + 42, &yppm, sizeof(yppm));
	header_buf[46] = 0;
	header_buf[47] = 0;
	header_buf[48] = 0;
	header_buf[49] = 0;
	header_buf[50] = 0;
	header_buf[51] = 0;
	header_buf[52] = 0;
	header_buf[53] = 0;

	//wb_̏
	fwrite(header_buf, sizeof(unsigned char), HEADERSIZE, fp);
	
	if((bmp_line_data = (unsigned char *)malloc(sizeof(unsigned char)*real_width)) == NULL)
	{
		fprintf(stderr, "Error: Allocation error.\n");
		fclose(fp);
		return 1;
	}
	
	//RGB̏
	for(i=0; i<img->height; i++)
	{
		for(j=0; j<img->width; j++)
		{
			bmp_line_data[j*3]			=	img->data[(img->height - i - 1)*img->width + j].b;
			bmp_line_data[j*3 + 1]		=	img->data[(img->height - i - 1)*img->width + j].g;
			bmp_line_data[j*3 + 2]		=	img->data[(img->height - i - 1)*img->width + j].r;
		}
		//RGB4oCg̔{ɍ킹Ă
		for(j=img->width*3; j<real_width; j++){
			bmp_line_data[j] = 0;
		}
		fwrite(bmp_line_data, sizeof(unsigned char), real_width, fp);
	}

	free(bmp_line_data);

	fclose(fp);

	return 0;
}

Image *Create_Image(int width, int height)
{
	Image *img;

	if((img = (Image *)malloc(sizeof(Image))) == NULL)
	{
		fprintf(stderr, "Allocation error\n");
		return NULL;
	}

	if((img->data = (Rgb*)malloc(sizeof(Rgb)*width*height)) == NULL)
	{
		fprintf(stderr, "Allocation error\n");
		free(img);
		return NULL;
	}

	img->width = width;
	img->height = height;

	return img;
}

//IɎ擾RGB̊J
void Free_Image(Image *img)
{
	free(img->data);
	free(img);
}


